#
# NOT WORKING: This is due to upgrades that now need to be done to the git rust stack
#              and this work will be completed in the future by the Rust SIG.
#
# Problem: nothing provides requested (crate(git2/default) >= 0.19.0 with crate(git2/default) < 0.20.0~)


%bcond_without check
%global cargo_install_lib  0
%global forgeurl           https://gitlab.com/gabmus/envision
%global commit             a34faa9cd7fa5f4fe658092efd509e8f5257f569
%global date               20241002

# Sync with Cargo.toml libmonado-rs git commit
%global forgeurl1          https://github.com/technobaboo/libmonado-rs
%global commit1            6edb1163627d87db9904c57d7ed9dd4dcc7228b7
%forgemeta


Name:           envision
Version:        0.1.0
Release:        %autorelease
Summary:        UI for building, configuring, and running Monado/WiVRn

License:        AGPL-3.0-only
URL:            %{forgeurl}
Source0:        %{forgesource}
# License: MIT
Source1:        %{forgeurl1}/archive/%{commit1}/libmonado-rs-%{commit1}.tar.gz
# downstream-only - bundle libmonado-rs, for now
Patch1:         envision-0.1.0-bundle-libmonado-rs.patch

BuildRequires:  cargo
BuildRequires:  cargo-rpm-macros >= 26
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  eigen3
BuildRequires:  g++
BuildRequires:  gdb-gdbserver
BuildRequires:  git
BuildRequires:  glib2-devel
BuildRequires:  glslang
BuildRequires:  glslc
BuildRequires:  gtk4-devel
BuildRequires:  gtksourceview5-devel
BuildRequires:  libadwaita-devel
BuildRequires:  libdrm
BuildRequires:  libgudev-devel
BuildRequires:  libusb1-devel
BuildRequires:  libXrandr-devel
BuildRequires:  mesa-libGL-devel
BuildRequires:  meson
BuildRequires:  openssl-devel
BuildRequires:  openxr-devel
BuildRequires:  rustc
BuildRequires:  vte291-gtk4-devel
BuildRequires:  vulkan-headers
BuildRequires:  vulkan-loader-devel

Suggests:       android-tools

Provides:       bundled(rust-libmonado) = 0.1.0


%description
UI for building, configuring, and running Monado, the open source 
OpenXR runtime.

This is still highly experimental software, while it's unlikely that 
anything bad will happen, it's still unstable and there is no guarantee 
that it will work on your system, with your particular hardware. If you 
encounter any problems while using the app, make sure to open an issue.

Also consider that due to the unstable nature of the app, it's possible 
to encounter unexpected behavior that while in VR might cause motion 
sickness or physical injury. Be very careful while in VR using this app!


%prep
%forgeautosetup -p1 -Sgendiff
%cargo_prep

# Add libmonado-rs
mkdir -p libmonado-rs
tar -xvf %{SOURCE1} --strip-components 1 -C libmonado-rs

%generate_buildrequires
%cargo_generate_buildrequires


%build
%meson
%meson_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies


%install
%meson_install


%if %{with check}
%check
%meson_test
%endif


%files
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%doc meson_options.txt
%{_bindir}/envision
%{_datarootdir}/envision
%{_datarootdir}/applications/org.gabmus.envision.Devel.desktop
%{_datarootdir}/icons/hicolor/scalable/apps/org.gabmus.envision.Devel.svg
%{_datarootdir}/icons/hicolor/symbolic/apps/org.gabmus.envision.Devel-symbolic.svg
%{_datarootdir}/metainfo/org.gabmus.envision.Devel.appdata.xml


%changelog
%autochangelog
